--[[----------------------------------------------------------------------------

ADOBE CONFIDENTIAL
------------------
Copyright 2015 Adobe Systems Incorporated
All Rights Reserved.

NOTICE: All information contained herein is, and remain the property of
Adobe Systems Incorporated and its suppliers, if any. The intellectual and
technical concepts contained herein are proprietary to Adobe Systems
Incorporated and its suppliers and may be covered by U.S. and Foreign
Patents, patents in process, and are protected by trade secret or copyright
law.  Dissemination of this information or reproduction of this material is
strictly forbidden unless prior written permission is obtained from
Adobe Systems Incorporated.

----------------------------------------------------------------------------]]--

	-- WF.core.rxlua
local WFRxTestCase = require 'WFRxTestCase'

	-- WF.lrmobile
local LrmLibraryModelUtils = require 'LrmLibraryModelUtils'

--==============================================================================

local LrmLibraryModelUtilsTest = {}

--------------------------------------------------------------------------------

function LrmLibraryModelUtilsTest.rxTestSubmodelFactoryCreation( rxTest )

	local libraryModel = {
		catalog = {
		}
	}
	
	setmetatable( libraryModel.catalog, { __tostring = function() return 'CatalogImpl' end } )
	
	local results
	
	local function modelCreationFn( catalog, ... )
	
		results = { ... }
		
		table.insert( results, tostring( catalog ) )
		
	end
	
	local submodelFn = LrmLibraryModelUtils.makeSubmodelFactoryFn( modelCreationFn )
	
	submodelFn( libraryModel, 'param1', true, 42 )
	
	rxTest:expectEqual( results[ 1 ], 'param1' )
	rxTest:expectEqual( results[ 2 ], true )
	rxTest:expectEqual( results[ 3 ], 42 )
	rxTest:expectEqual( results[ 4 ], 'CatalogImpl' )
	
end


--------------------------------------------------------------------------------

return WFRxTestCase.wrapSuite( 'LrmLibraryModelUtilsTest', LrmLibraryModelUtilsTest )
